#ifndef _STATISTICS_H
#define _STATISTICS_H
double getmean(int, double *);
double getmean_double(int, double *);
float getmean_float(int, float *);
int getmean_int(int, int *);
long getmean_long(int, long *);
short getmean_short(int, short *);
double getweightedmean(int n, double *data, double *sig);
double getweightedmean_double(int n, double *data, double *sig);
float getweightedmean_float(int n, float *data, double *sig);
int getweightedmean_int(int n, int *data, double *sig);
long getweightedmean_long(int n, long *data, double *sig);
short getweightedmean_short(int n, short *data, double *sig);
double median(int, double *);
double median_double(int, double *);
float median_float(int, float *);
int median_int(int, int *);
long median_long(int, long *);
short median_short(int, short *);
double median_nocopy(int, double *);
double median_nocopy_double(int, double *);
float median_nocopy_float(int, float *);
int median_nocopy_int(int, int *);
long median_nocopy_long(int, long *);
short median_nocopy_short(int, short *);
double median_weight(int, double *, double *);
double median_weight_double(int, double *, double *);
float median_weight_float(int, float *, double *);
int median_weight_int(int, int *, double *);
long median_weight_long(int, long *, double *);
short median_weight_short(int, short *, double *);
double median_weight_nocopy(int, double *, double *);
double median_weight_nocopy_double(int, double *, double *);
float median_weight_nocopy_float(int, float *, double *);
int median_weight_nocopy_int(int, int *, double *);
long median_weight_nocopy_long(int, long *, double *);
short median_weight_nocopy_short(int, short *, double *);
double medmeddev(int, double *);
double medmeddev_double(int, double *);
float medmeddev_float(int, float *);
int medmeddev_int(int, int *);
long medmeddev_long(int, long *);
short memeddev_short(int, short *);
double MAD(int, double *);
double MAD_double(int, double *);
float MAD_float(int, float *);
int MAD_int(int, int *);
long MAD_long(int, long *);
short MAD_short(int, short *);
double meddev(int, double *);
double meddev_double(int, double *);
float meddev_float(int, float *);
int meddev_int(int, int *);
long meddev_long(int, long *);
short meddev_short(int, short *);
double stddev(int, double *);
double stddev_double(int, double *);
float stddev_float(int, float *);
int stddev_int(int, int *);
long stddev_long(int, long *);
short stddev_short(int, short *);
double kurtosis(int, double *);
double kurtosis_double(int, double *);
float kurtosis_float(int, float *);
int kurtosis_int(int, int *);
long kurtosis_long(int, long *);
short kurtosis_short(int, short *);
double skewness(int, double *);
double skewness_double(int, double *);
float skewness_float(int, float *);
int skewness_int(int, int *);
long skewness_long(int, long *);
short skewness_short(int, short *);
double percentile(int, double *, double);
double percentile_double(int, double *, double);
float percentile_float(int, float *, double);
int percentile_int(int, int *, double);
long percentile_long(int, long *, double);
short percentile_short(int, short *, double);
double percentile_nocopy(int, double *, double);
double percentile_nocopy_double(int, double *, double);
float percentile_nocopy_float(int, float *, double);
int percentile_nocopy_int(int, int *, double);
long percentile_nocopy_long(int, long *, double);
short percentile_nocopy_short(int, short *, double);
double percentile_weight(int, double *, double *, double);
double percentile_weight_double(int, double *, double *, double);
float percentile_weight_float(int, float *, double *, double);
int percentile_weight_int(int, int *, double *, double);
long percentile_weight_long(int, long *, double *, double);
short percentile_weight_short(int, short *, double *, double);
double percentile_weight_nocopy(int, double *, double *, double);
double percentile_weight_nocopy_double(int, double *, double *, double);
float percentile_weight_nocopy_float(int, float *, double *, double);
int percentile_weight_nocopy_int(int, int *, double *, double);
long percentile_weight_nocopy_long(int, long *, double *, double);
short percentile_weight_nocopy_short(int, short *, double *, double);
double getmaximum(int, double *);
double getmaximum_double(int, double *);
float getmaximum_float(int, float *);
int getmaximum_int(int, int *);
long getmaximum_long(int, long *);
short getmaximum_short(int, short *);
double getminimum(int, double *);
double getminimum_double(int, double *);
float getminimum_float(int, float *);
int getminimum_int(int, int *);
long getminimum_long(int, long *);
short getminimum_short(int, short *);
double getsum(int, double *);
double getsum_double(int, double *);
float getsum_float(int, float *);
int getsum_int(int, int *);
long getsum_long(int, long *);
short getsum_short(int, short *);
#endif
